﻿@using System.Globalization
@using LoyaltyPointEngine.Model.Object.Member;
@model List<MemberReportElasticModel>
@{
    string orderColumn = ViewBag.OrderColumn,
        orderDirection = ViewBag.OrderDirection,
        startDate = ViewBag.StartDate,
        endDate = ViewBag.EndDate;

    bool? memberWithReceipt = ViewBag.MemberWithReceipt;

    int? channelId = ViewBag.ChannelId;

    int currentPage = ViewBag.CurrentPage,
        totalPage = ViewBag.TotalPage,
        pageSize = ViewBag.PageSize,
        totalRow = ViewBag.TotalRow;
}

<div id="grid-wrapper" class="widget-content">
    <table class="table table-striped grid-table">
        <thead>
            <tr>
                @RenderTableHead(startDate, endDate, channelId, memberWithReceipt, orderDirection, currentPage)
                <th class="grid-header cell-center" title=""><div class="grid-header-title"><span></span></div></th>
                <th class="grid-header cell-center" title=""><div class="grid-header-title"><span></span></div></th>
            </tr>
        </thead>
        <tbody>
            @foreach (MemberReportElasticModel receipt in Model)
            {
                @RenderTableRow(receipt, startDate, endDate, channelId, orderDirection, 1)
            }
        </tbody>
    </table>
    @if (totalPage > 1)
    {
        int startPage = currentPage - pageSize > 1 ? currentPage - pageSize : 1,
            endPage = currentPage + pageSize < totalPage ? currentPage + pageSize : totalPage;

        <div class="grid-footer">

            <div class="grid-pager">
                <ul class="pagination">
                    <li>
                        <a data-url="@GenerateUrl(startDate, endDate, channelId, memberWithReceipt, orderColumn, orderDirection, currentPage <= 1 ? currentPage : currentPage - 1)" class="grid-prev-page" title="Previous Page" style="">
                            <span class="glyphicon glyphicon-step-backward"></span>
                        </a>
                    </li>
                    @for (var _page = startPage; _page <= endPage; _page++)
                    {
                        <li class="@(currentPage == _page ? "active": "")">
                            <a data-url="@GenerateUrl(startDate, endDate, channelId, memberWithReceipt, orderColumn, orderDirection, _page)" class="grid-page-link">
                                @_page
                            </a>
                        </li>
                    }
                    @if (totalPage >= 7)
                    {
                        <li>
                            <a class="grid-page-link">
                                Total Page @totalPage
                            </a>
                        </li>
                    }
                    <li>
                        <a data-url="@GenerateUrl(startDate, endDate, channelId, memberWithReceipt, orderColumn, orderDirection, currentPage >= endPage ? endPage : currentPage + 1)" title="Next Page" class="grid-next-page">
                            <span class="glyphicon glyphicon-step-forward"></span>
                        </a>
                    </li>
                </ul>
            </div>
            <div>
                Total Row : @totalRow
            </div>
        </div>
    }
</div>

@helper RenderTableHead(string startDate, string endDate, int? channelId, bool? memberWithReceipt, string orderDirection, int page)
{
    Type type = typeof(MemberReportElasticModel);
    foreach (var prop in type.GetProperties())
    {
        if (prop.Name.ToLower() != "isactivestring" && prop.Name.ToLower() != "isactive")
        {
            <th class="grid-header" title="@prop.Name">
                <div class="grid-header-title">
                    <a data-url="@GenerateUrl(startDate, endDate, channelId, memberWithReceipt, prop.Name, orderDirection, page, true)">@prop.Name</a>
                </div>
            </th>
        }
        else if (prop.Name.ToLower() == "isactivestring")
        {
            <th class="grid-header" title="IsActive">
                <div class="grid-header-title">
                    <a data-url="@GenerateUrl(startDate, endDate, channelId, memberWithReceipt, prop.Name, orderDirection, page, true)">IsActive</a>
                </div>
            </th>
        }
    }
}

@helper RenderTableRow(MemberReportElasticModel data, string startDate, string endDate, int? channelId, string orderDirection, int page)
{
    Type type = typeof(MemberReportElasticModel);
    <tr class="grid-row">
        @foreach (var prop in type.GetProperties())
        {
            string valueStr = "";
            object valueObj = prop.GetValue(data);
            if (valueObj != null)
            {
                if (prop.PropertyType == typeof(DateTime?) || prop.PropertyType == typeof(DateTime))
                {
                    if (((DateTime)valueObj) == DateTime.MinValue)
                    {
                        valueStr = "";
                    }
                    else
                    {
                        valueStr = ((DateTime)valueObj).ToLocalTime().ToString("dd/MM/yyyy hh:mm:ss tt", CultureInfo.InvariantCulture);
                    }
                }
                else
                {
                    valueStr = valueObj.ToString();
                }
            }
            if (prop.Name.ToLower() == "isactive")
            {
                continue;
            }
            <td class="grid-cell" data-name="@prop.Name">@valueStr</td>
        }
    </tr>
}

@functions {
    public string GenerateUrl(string startDate, string endDate, int? channelId, bool? memberWithReceipt, string orderColumn, string orderDirection, int page, bool isSorting = false)
    {
        if (isSorting)
        {
            orderDirection = orderDirection.ToUpper() == "DESC" ? "ASC" : "DESC";
        }
        return Url.Action(MVC.MemberReporting.GridGetAllPager(startDate, endDate, channelId, memberWithReceipt, orderColumn, orderDirection, page));
    }
}